## org.eclipse.uml2.uml
Interface LinkEndData

All Superinterfaces:
  Element, org.eclipse.emf.ecore.EModelElement, org.eclipse.emf.ecore.EObject, org.eclipse.emf.common.notify.Notifier

All Known Subinterfaces:
  LinkEndCreationData, LinkEndDestructionData

    public interface LinkEndData

extends Element

A representation of the model object 'Link End Data'. A link end data is not an action. It is an element that identifies links. It identifies one end of a link to be read or written by the children of a link action. A link cannot be passed as a runtime value to or from an action. Instead, a link is identified by its end objects and qualifier values, if any. This requires more than one piece of data, namely, the statically-specified end in the user model, the object on the end, and the qualifier values for that end, if any. These pieces are brought together around a link end data. Each association end is identified separately with an instance of the LinkEndData class.

The following features are supported:

- `Value`
- `End`
- `Qualifier`

See Also:
  `UMLPackage.getLinkEndData()`

Method Summary
`QualifierValue` `createQualifier()` Creates a new `QualifierValue` and appends it to the 'Qualifier' containment reference list
`Property` `getEnd()` Returns the value of the 'End' reference
`org.eclipse.emf.common.util.EList<QualifierValue>` `getQualifiers()` Returns the value of the 'Qualifier' containment reference list.
`InputPin` `getValue()` Returns the value of the 'Value' reference
`void` `setEnd(Property value)` Sets the value of the '`End`' reference
`void` `setValue(InputPin value)` Sets the value of the '`Value`' reference
`boolean` `validateEndObjectInputPin(org.eclipse.emf.common.util.DiagnosticChain diagnostics, java.util.Map<java.lang.Object,java.lang.Object> context)` The end object input pin is not also a qualifier value input pin.
`boolean` `validateMultiplicity(org.eclipse.emf.common.util.DiagnosticChain diagnostics, java.util.Map<java.lang.Object,java.lang.Object> context)` The multiplicity of the end object input pin must be 1..1.
`boolean` `validatePropertyIsAssociationEnd(org.eclipse.emf.common.util.DiagnosticChain diagnostics, java.util.Map<java.lang.Object,java.lang.Object> context)` The property must be an association end.
`boolean` `validateQualifiers(org.eclipse.emf.common.util.DiagnosticChain diagnostics, java.util.Map<java.lang.Object,java.lang.Object> context)` The qualifiers include all and only the qualifiers of the association end.
`boolean` `validateSameType(org.eclipse.emf.common.util.DiagnosticChain diagnostics, java.util.Map<java.lang.Object,java.lang.Object> context)` The type of the end object input pin is the same as the type of the association end.

Methods inherited from interface org.eclipse.uml2.uml.Element

`addKeyword, allOwnedElements, applyStereotype, createEAnnotation, createOwnedComment, destroy, getApplicableStereotype, getApplicableStereotypes, getAppliedStereotype, getAppliedStereotypes, getAppliedSubstereotype, getAppliedSubstereotypes, getKeywords, getModel, getNearestPackage, getOwnedComments, getOwnedElements, getOwner, getRelationships, getRelationships, getRequiredStereotype, getRequiredStereotypes, getSourceDirectedRelationships, getSourceDirectedRelationships, getStereotypeApplication, getStereotypeApplications, getTargetDirectedRelationships, getTargetDirectedRelationships, getValue, hasKeyword, hasValue, isStereotypeApplicable, isStereotypeApplied, isStereotypeRequired, mustBeOwned, removeKeyword, setValue, unapplyStereotype, validateHasOwner, validateNotOwnSelf`

Methods inherited from interface org.eclipse.emf.ecore.EModelElement
`getEAnnotation, getEAnnotations`

Methods inherited from interface org.eclipse.emf.ecore.EObject
`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eInvoke, eIsProxy, eIsSet, eResource, eSet, eUnset`

Methods inherited from interface org.eclipse.emf.common.notify.Notifier
`eAdapters, eDeliver, eNotify, eSetDeliver`

Method Detail

### getValue

    InputPin getValue()

  Returns the value of the 'Value' reference. Input pin that provides the specified object for the given end. This pin is omitted if the link-end data specifies an 'open' end for reading.

  Returns:
    the value of the 'Value' reference.
  See Also:
    `setValue(InputPin)`, `UMLPackage.getLinkEndData_Value()`

### setValue

    void setValue(InputPin value)

  Sets the value of the '`Value`' reference.

  Parameters:
    `value` - the new value of the 'Value' reference.
  See Also:
    `getValue()`

### getEnd

    Property getEnd()

  Returns the value of the 'End' reference. Association end for which this link-end data specifies values.

  Returns:
    the value of the 'End' reference.
  See Also:
    `setEnd(Property)`, `UMLPackage.getLinkEndData_End()`

### setEnd

    void setEnd(Property value)

  Sets the value of the '`End`' reference.

  Parameters:
    `value` - the new value of the 'End' reference.
  See Also:
    `getEnd()`

### getQualifiers

    org.eclipse.emf.common.util.EList<QualifierValue> getQualifiers()

  Returns the value of the 'Qualifier' containment reference list. The list contents are of type `QualifierValue`. List of qualifier values

  Returns:
    the value of the 'Qualifier' containment reference list.
  See Also:
    `UMLPackage.getLinkEndData_Qualifier()`

### createQualifier

    QualifierValue createQualifier()

  Creates a new `QualifierValue` and appends it to the 'Qualifier' containment reference list.

  Returns:
    The new `QualifierValue`.
  See Also:
    `getQualifiers()`

### validatePropertyIsAssociationEnd

    boolean validatePropertyIsAssociationEnd(org.eclipse.emf.common.util.DiagnosticChain diagnostics,
                                             java.util.Map<java.lang.Object,java.lang.Object> context)

  The property must be an association end. self.end.association->size() = 1

  Parameters:
    `diagnostics` - The chain of diagnostics to which problems are to be appended.
    `context` - The cache of context-specific information.

### validateSameType

    boolean validateSameType(org.eclipse.emf.common.util.DiagnosticChain diagnostics,
                             java.util.Map<java.lang.Object,java.lang.Object> context)

  The type of the end object input pin is the same as the type of the association end. self.value.type = self.end.type

  Parameters:
    `diagnostics` - The chain of diagnostics to which problems are to be appended.
    `context` - The cache of context-specific information.

### validateMultiplicity

    boolean validateMultiplicity(org.eclipse.emf.common.util.DiagnosticChain diagnostics,
                                 java.util.Map<java.lang.Object,java.lang.Object> context)

  The multiplicity of the end object input pin must be 1..1. self.value.multiplicity.is(1,1)

  Parameters:
    `diagnostics` - The chain of diagnostics to which problems are to be appended.
    `context` - The cache of context-specific information.

### validateQualifiers

    boolean validateQualifiers(org.eclipse.emf.common.util.DiagnosticChain diagnostics,
                               java.util.Map<java.lang.Object,java.lang.Object> context)

  The qualifiers include all and only the qualifiers of the association end. self.qualifier->collect(qualifier) = self.end.qualifier

  Parameters:
    `diagnostics` - The chain of diagnostics to which problems are to be appended.
    `context` - The cache of context-specific information.

### validateEndObjectInputPin

    boolean validateEndObjectInputPin(org.eclipse.emf.common.util.DiagnosticChain diagnostics,
                                      java.util.Map<java.lang.Object,java.lang.Object> context)

  The end object input pin is not also a qualifier value input pin. self.value->excludesAll(self.qualifier.value)

  Parameters:
    `diagnostics` - The chain of diagnostics to which problems are to be appended.
    `context` - The cache of context-specific information.

Copyright 2003, 2007 IBM Corporation and others. All Rights Reserved.